Index: issm/trunk/src/c/modules/Bamgx/Bamgx.cpp
===================================================================
--- issm/trunk/src/c/modules/Bamgx/Bamgx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Bamgx/Bamgx.cpp	(revision 13395)
@@ -3,5 +3,5 @@
  */
 #include "./Bamgx.h"
-#include "../../objects/objects.h"
+#include "../../classes/bamg/bamgobjects.h"
 #include "../../shared/shared.h"
 #include "../../include/include.h"
@@ -119,5 +119,5 @@
 			if (verbosity>1) _printLine_("   Merging Metric with hVertices...");
 			for (i=0;i<BTh.nbv;i++){
-				if (!xIsNan<IssmDouble>(bamgopts->hVertices[i])){
+				if (!xIsNan<IssmPDouble>(bamgopts->hVertices[i])){
 					BTh[i].m=Metric((float)bamgopts->hVertices[i]);
 				}
@@ -129,5 +129,5 @@
 			if (verbosity>1) _printLine_("   Merging Metric with hminVertices...");
 			for (i=0;i<BTh.nbv;i++){
-				if (!xIsNan<IssmDouble>(bamgopts->hminVertices[i])){
+				if (!xIsNan<IssmPDouble>(bamgopts->hminVertices[i])){
 					Metric M=BTh.vertices[i].m;
 					EigenMetric Vp(M/coef);
@@ -142,5 +142,5 @@
 			if (verbosity>1) _printLine_("   Merging Metric with hmaxVertices...");
 			for (i=0;i<BTh.nbv;i++){
-				if (!xIsNan<IssmDouble>(bamgopts->hmaxVertices[i])){
+				if (!xIsNan<IssmPDouble>(bamgopts->hmaxVertices[i])){
 					Metric M=BTh.vertices[i].m;
 					EigenMetric Vp(M/coef);
Index: issm/trunk/src/c/modules/Bamgx/Bamgx.h
===================================================================
--- issm/trunk/src/c/modules/Bamgx/Bamgx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Bamgx/Bamgx.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define _BAMGX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/bamg/bamgobjects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/Chacox/Chacox.h
===================================================================
--- issm/trunk/src/c/modules/Chacox/Chacox.h	(revision 12709)
+++ issm/trunk/src/c/modules/Chacox/Chacox.h	(revision 13395)
@@ -33,5 +33,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.cpp
===================================================================
--- issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void	ComputeBasalStressx( Vector** psigma,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,Parameters* parameters){
+void	ComputeBasalStressx( Vector<IssmDouble>** psigma,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,Parameters* parameters){
 
 	/*Intermediary*/
@@ -19,5 +19,5 @@
 
 	/*output: */
-	Vector* sigma=NULL;
+	Vector<IssmDouble>* sigma=NULL;
 
 	/*Recover numberofelements: */
@@ -25,5 +25,5 @@
 
 	/*Allocate sigma on numberofelements: */
-	sigma=new Vector(reCast<int>(numberofelements));
+	sigma=new Vector<IssmDouble>(reCast<int>(numberofelements));
 
 	/*Compute basal stress for each element: */
Index: issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.h
===================================================================
--- issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.h	(revision 13395)
@@ -6,9 +6,9 @@
 #define _COMPUTEBASALSTRESSX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void	ComputeBasalStressx( Vector** pp_g,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
+void	ComputeBasalStressx( Vector<IssmDouble>** pp_g,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
 
 #endif  /* _COMPUTEBASALSTRESSX_H */
Index: issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.cpp
===================================================================
--- issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void	ComputeStrainRatex( Vector** peps,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,Parameters* parameters){
+void	ComputeStrainRatex( Vector<IssmDouble>** peps,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,Parameters* parameters){
 
 	/*Intermediary*/
@@ -19,5 +19,5 @@
 
 	/*output: */
-	Vector* eps=NULL;
+	Vector<IssmDouble>* eps=NULL;
 
 	/*Recover numberofelements: */
@@ -25,5 +25,5 @@
 
 	/*Allocate eps on numberofelements (only 1 dof): */
-	eps=new Vector(numberofelements);
+	eps=new Vector<IssmDouble>(numberofelements);
 
 	/*Compute basal stress for each element: */
Index: issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.h
===================================================================
--- issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.h	(revision 12709)
+++ issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.h	(revision 13395)
@@ -6,9 +6,9 @@
 #define _COMPUTESTRAINRATEX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void	ComputeStrainRatex(Vector** eps_g,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
+void	ComputeStrainRatex(Vector<IssmDouble>** eps_g,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
 
 #endif  /* _COMPUTESTRAINRATEX_H */
Index: issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStateLocal.h
===================================================================
--- issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStateLocal.h	(revision 12709)
+++ issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStateLocal.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /*melting: */
Index: issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStatex.h
===================================================================
--- issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStatex.h	(revision 12709)
+++ issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStatex.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.cpp
===================================================================
--- issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.cpp	(revision 13395)
@@ -11,5 +11,5 @@
 #include "./ContourToMeshx.h"
 
-int ContourToMeshx( Vector** pin_nod,Vector** pin_elem, double* index, double* x, double* y,DataSet* contours,char* interptype,int nel,int nods, int edgevalue) {
+int ContourToMeshx(SeqVec<double>** pin_nod,SeqVec<double>** pin_elem, double* index, double* x, double* y,DataSet* contours,char* interptype,int nel,int nods, int edgevalue) {
 
 	int noerr=1;
@@ -30,9 +30,8 @@
 
 	/*output: */
-	Vector* in_nod=NULL;
-	Vector* in_elem=NULL;
-
-	in_nod=new Vector(nods);
-	in_elem=new Vector(nel);
+	SeqVec<double>* in_nod=NULL;
+	SeqVec<double>* in_elem=NULL;
+	in_nod  = new SeqVec<double>(nods);
+	in_elem = new SeqVec<double>(nel);
 
 	/*initialize thread parameters: */
Index: issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.h
===================================================================
--- issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.h	(revision 13395)
@@ -8,15 +8,15 @@
 
 #include "../../shared/shared.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /*threading: */
 typedef struct{
 
-	DataSet* contours;
-	int nods;
-	int edgevalue;
-	Vector* in_nod;
-	double* x;
-	double* y;
+	DataSet *contours;
+	int    nods;
+	int    edgevalue;
+	SeqVec<double> *in_nod;
+	double *x;
+	double *y;
 
 } ContourToMeshxThreadStruct;
@@ -24,9 +24,7 @@
 
 /* local prototypes: */
-int ContourToMeshx( Vector** pin_nods,Vector** pin_elem, double* index, double* x, double* y,DataSet* contours,char* interptype,int nel,int nods, int edgevalue);
+int ContourToMeshx(SeqVec<double>** pin_nods,SeqVec<double>** pin_elem, double* index, double* x, double* y,DataSet* contours,char* interptype,int nel,int nods, int edgevalue);
 
 void* ContourToMeshxt(void* vContourToMeshxThreadStruct);
 
-
 #endif /* _CONTOURTOMESHX_H */
-
Index: issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshxt.cpp
===================================================================
--- issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshxt.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshxt.cpp	(revision 13395)
@@ -33,6 +33,5 @@
 	double* x=NULL;
 	double* y=NULL;
-	Vector* in_nod=NULL;
-
+	SeqVec<double>* in_nod=NULL;
 
 	/*recover handle and gate: */
@@ -55,9 +54,8 @@
 	/*Loop through all contours: */
 	for (i=0;i<contours->Size();i++){
-		Contour* contour=(Contour*)contours->GetObjectByOffset(i);
+		Contour<double>* contour=(Contour<double>*)contours->GetObjectByOffset(i);
 		IsInPoly(in_nod,contour->x,contour->y,contour->nods,x,y,i0,i1,edgevalue);
 	}
 
 	return NULL;
-
 }
Index: issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.cpp
===================================================================
--- issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 #include "./ContourToNodesx.h"
 
-int ContourToNodesx( Vector** pflags,double* x, double* y, int nods, Contour** contours,int numcontours,int edgevalue){
+int ContourToNodesx(SeqVec<IssmPDouble>** pflags,double* x, double* y, int nods, Contour<IssmPDouble>** contours,int numcontours,int edgevalue){
 
 	int i;
@@ -10,5 +10,5 @@
 
 	/*Contour:*/
-	Contour* contouri=NULL;
+	Contour<IssmPDouble>* contouri=NULL;
 	int      numnodes;
 	double*  xc=NULL;
@@ -17,7 +17,6 @@
 
 	/*output: */
-	Vector* flags=NULL;
-
-	flags=new Vector(nods);
+	SeqVec<IssmPDouble>* flags=NULL;
+	flags=new SeqVec<IssmPDouble>(nods);
 
 	/*Loop through all contours: */
@@ -39,5 +38,5 @@
 }
 
-int ContourToNodesx( Vector** pflags,double* x, double* y, int nods, DataSet* contours, int edgevalue){
+int ContourToNodesx(SeqVec<IssmPDouble>** pflags,double* x, double* y, int nods, DataSet* contours, int edgevalue){
 
 	int i;
@@ -45,5 +44,5 @@
 
 	/*Contour:*/
-	Contour* contouri=NULL;
+	Contour<IssmPDouble>* contouri=NULL;
 	int      numnodes;
 	double*  xc=NULL;
@@ -52,12 +51,11 @@
 
 	/*output: */
-	Vector* flags=NULL;
-
-	flags=new Vector(nods);
+	SeqVec<IssmPDouble>* flags=NULL;
+	flags=new SeqVec<IssmPDouble>(nods);
 
 	/*Loop through all contours: */
 	if(contours){
 		for (i=0;i<contours->Size();i++){
-			Contour* contour=(Contour*)contours->GetObjectByOffset(i);
+			Contour<IssmPDouble>* contour=(Contour<IssmPDouble>*)contours->GetObjectByOffset(i);
 			IsInPoly(flags,contour->x,contour->y,contour->nods,x,y,0,nods,edgevalue);
 		}
@@ -69,5 +67,4 @@
 	/*Assign output pointers: */
 	*pflags=flags;
-	
 	return 1;
 }
Index: issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.h
===================================================================
--- issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.h	(revision 13395)
@@ -2,5 +2,4 @@
 	ContourToNodesx.h
 */
-
 
 #ifndef _CONTOURTONODESX_H
@@ -8,10 +7,9 @@
 
 #include "../../shared/shared.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-int ContourToNodesx( Vector** pflags,double* x, double* y, int nods, Contour** contours,int numcontours,int edgevalue);
-int ContourToNodesx( Vector** pflags,double* x, double* y, int nods, DataSet* contours, int edgevalue);
+int ContourToNodesx(SeqVec<IssmPDouble>** pflags,double* x, double* y, int nods, Contour<IssmPDouble>** contours,int numcontours,int edgevalue);
+int ContourToNodesx(SeqVec<IssmPDouble>** pflags,double* x, double* y, int nods, DataSet* contours, int edgevalue);
 
 #endif /* _CONTOURTONODESX_H */
-
Index: issm/trunk/src/c/modules/ControlInputGetGradientx/ControlInputGetGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/ControlInputGetGradientx/ControlInputGetGradientx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ControlInputGetGradientx/ControlInputGetGradientx.cpp	(revision 13395)
@@ -9,10 +9,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void ControlInputGetGradientx( Vector** pgradient, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters){
+void ControlInputGetGradientx( Vector<IssmDouble>** pgradient, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters){
 
 	/*Intermediaries*/
 	int  num_controls;
 	int *control_type = NULL;
-	Vector*  gradient=NULL;
+	Vector<IssmDouble>*  gradient=NULL;
 
 	/*Retrieve some parameters*/
@@ -21,5 +21,5 @@
 
 	/*Allocate and populate gradient*/
-	gradient=new Vector(num_controls*vertices->NumberOfVertices());
+	gradient=new Vector<IssmDouble>(num_controls*vertices->NumberOfVertices());
 
 	for(int i=0;i<num_controls;i++){
Index: issm/trunk/src/c/modules/ControlInputGetGradientx/ControlInputGetGradientx.h
===================================================================
--- issm/trunk/src/c/modules/ControlInputGetGradientx/ControlInputGetGradientx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ControlInputGetGradientx/ControlInputGetGradientx.h	(revision 13395)
@@ -5,8 +5,8 @@
 #define _CONTROLINPUTGETGRADIENTX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
-void	ControlInputGetGradientx( Vector** pgradient, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
+void	ControlInputGetGradientx( Vector<IssmDouble>** pgradient, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters);
 
 #endif
Index: issm/trunk/src/c/modules/ControlInputScaleGradientx/ControlInputScaleGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/ControlInputScaleGradientx/ControlInputScaleGradientx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ControlInputScaleGradientx/ControlInputScaleGradientx.cpp	(revision 13395)
@@ -9,11 +9,11 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void ControlInputScaleGradientx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* norm_list,int step){
+void ControlInputScaleGradientx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* norm_list,int step){
 
 	/*Intermediaries*/
 	int     i,j,num_controls;
 	int    *control_type = NULL;
-	double *scalar_list = NULL;
-	double  scalar;
+	IssmDouble *scalar_list = NULL;
+	IssmDouble  scalar;
 
 
@@ -38,4 +38,4 @@
 	/*Clean up and return*/
 	xDelete<int>(control_type);
-	xDelete<double>(scalar_list);
+	xDelete<IssmDouble>(scalar_list);
 }
Index: issm/trunk/src/c/modules/ControlInputScaleGradientx/ControlInputScaleGradientx.h
===================================================================
--- issm/trunk/src/c/modules/ControlInputScaleGradientx/ControlInputScaleGradientx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ControlInputScaleGradientx/ControlInputScaleGradientx.h	(revision 13395)
@@ -5,8 +5,8 @@
 #define _CONTROLINPUTSSCALEGRADIENTX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
-void	ControlInputScaleGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,double* norm_list,int step);
+void	ControlInputScaleGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,IssmDouble* norm_list,int step);
 
 #endif
Index: issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.cpp	(revision 13395)
@@ -9,5 +9,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* gradient){
+void ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* gradient){
 
 	/*Intermediaries*/
@@ -30,8 +30,8 @@
 
 }
-void ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Vector* gradient){
+void ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Vector<IssmDouble>* gradient){
 
 	/*Serialize gradient*/
-	double* serial_gradient=NULL;
+	IssmDouble* serial_gradient=NULL;
 	serial_gradient=gradient->ToMPISerial();
 
@@ -39,4 +39,4 @@
 
 	/*Clean up and return*/
-	xDelete<double>(serial_gradient);
+	xDelete<IssmDouble>(serial_gradient);
 }
Index: issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.h
===================================================================
--- issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.h	(revision 13395)
@@ -5,9 +5,9 @@
 #define _CONTROLINPUTSSETGRADIENTX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 void	ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,double* gradient);
-void	ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector* gradient);
+void	ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector<IssmDouble>* gradient);
 
 #endif
Index: issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.cpp
===================================================================
--- issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.cpp	(revision 13395)
@@ -11,15 +11,14 @@
 #include "../Responsex/Responsex.h"
 
-void CostFunctionx(double* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters){
+void CostFunctionx(IssmDouble* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters){
 
 	/*Intermediary*/
 	int      i;
 	int      num_responses;
-	double   S;
 	Element *element       = NULL;
 	int     *responses     = NULL;
 
 	/*output: */
-	double J,Jplus;
+	IssmDouble J,Jplus;
 	
 	/*Recover parameters*/
Index: issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.h
===================================================================
--- issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.h	(revision 12709)
+++ issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void CostFunctionx( double* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters);
+void CostFunctionx( IssmDouble* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters);
 
 #endif
Index: issm/trunk/src/c/modules/CreateJacobianMatrixx/CreateJacobianMatrixx.cpp
===================================================================
--- issm/trunk/src/c/modules/CreateJacobianMatrixx/CreateJacobianMatrixx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/CreateJacobianMatrixx/CreateJacobianMatrixx.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void CreateJacobianMatrixx(Matrix** pJff,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,IssmDouble kmax){
+void CreateJacobianMatrixx(Matrix<IssmDouble>** pJff,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,IssmDouble kmax){
 	
 	int      i,connectivity;
@@ -17,5 +17,5 @@
 	Element *element = NULL;
 	Load    *load    = NULL;
-	Matrix*  Jff     = NULL;
+	Matrix<IssmDouble>*  Jff     = NULL;
 
 	/*Checks*/
@@ -29,5 +29,5 @@
 
 	/*Initialize Jacobian Matrix*/
-	Jff=new Matrix(fsize,fsize,connectivity,numberofdofspernode);
+	Jff=new Matrix<IssmDouble>(fsize,fsize,connectivity,numberofdofspernode);
 	
 	/*Create and assemble matrix*/
Index: issm/trunk/src/c/modules/CreateJacobianMatrixx/CreateJacobianMatrixx.h
===================================================================
--- issm/trunk/src/c/modules/CreateJacobianMatrixx/CreateJacobianMatrixx.h	(revision 12709)
+++ issm/trunk/src/c/modules/CreateJacobianMatrixx/CreateJacobianMatrixx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void CreateJacobianMatrixx(Matrix** pJff,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,IssmDouble kmax);
+void CreateJacobianMatrixx(Matrix<IssmDouble>** pJff,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,IssmDouble kmax);
 
 #endif  /* _CREATEJACOBIANMATRIXX_H */
Index: issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void CreateNodalConstraintsx( Vector** pys, Nodes* nodes,int configuration_type){
+void CreateNodalConstraintsx( Vector<IssmDouble>** pys, Nodes* nodes,int configuration_type){
 
 	int i;
@@ -18,5 +18,5 @@
 
 	/*output: */
-	Vector* ys=NULL;
+	Vector<IssmDouble>* ys=NULL;
 
 	/*figure out how many dofs we have: */
@@ -24,5 +24,5 @@
 
 	/*allocate:*/
-	ys=new Vector(numberofdofs);
+	ys=new Vector<IssmDouble>(numberofdofs);
 
 	/*go through all nodes, and for the ones corresponding to this configuration_type, fill the 
Index: issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.h
===================================================================
--- issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.h	(revision 13395)
@@ -6,8 +6,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void CreateNodalConstraintsx( Vector** pys, Nodes* nodes,int configuration_type);
+void CreateNodalConstraintsx( Vector<IssmDouble>** pys, Nodes* nodes,int configuration_type);
 
 #endif  /* _CREATENODALCONSTRAINTSX_H */
Index: issm/trunk/src/c/modules/DakotaResponsesx/DakotaResponsesx.cpp
===================================================================
--- issm/trunk/src/c/modules/DakotaResponsesx/DakotaResponsesx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/DakotaResponsesx/DakotaResponsesx.cpp	(revision 13395)
@@ -86,5 +86,5 @@
 		}
 		else if (flag==NodalEnum){
-			_error2_("nodal response functions not supported yet!");
+			_error_("nodal response functions not supported yet!");
 
 			/*increment response_pointer :*/
@@ -104,5 +104,5 @@
 			}
 		}
-		else _error2_("flag type " << flag << " not supported yet for response analysis");
+		else _error_("flag type " << flag << " not supported yet for response analysis");
 	}
 
Index: issm/trunk/src/c/modules/DakotaResponsesx/DakotaResponsesx.h
===================================================================
--- issm/trunk/src/c/modules/DakotaResponsesx/DakotaResponsesx.h	(revision 12709)
+++ issm/trunk/src/c/modules/DakotaResponsesx/DakotaResponsesx.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define _DAKOTARESPONSESXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/trunk/src/c/modules/Dakotax/Dakotax.cpp
===================================================================
--- issm/trunk/src/c/modules/Dakotax/Dakotax.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Dakotax/Dakotax.cpp	(revision 13395)
@@ -40,5 +40,5 @@
 #include "../../toolkits/toolkits.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
-#include "../../objects/DakotaPlugin.h"
+#include "../../classes/dakota/DakotaPlugin.h"
 
 #ifdef _HAVE_DAKOTA_ //only works if dakota library has been compiled in.
Index: issm/trunk/src/c/modules/Dakotax/Dakotax.h
===================================================================
--- issm/trunk/src/c/modules/Dakotax/Dakotax.h	(revision 12709)
+++ issm/trunk/src/c/modules/Dakotax/Dakotax.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/Dakotax/DescriptorIndex.cpp
===================================================================
--- issm/trunk/src/c/modules/Dakotax/DescriptorIndex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Dakotax/DescriptorIndex.cpp	(revision 13395)
@@ -23,10 +23,10 @@
 	/*retrieve first token, separated by underscore: */
 	pch = strtok (descriptor,"_");
-	if(!pch)_error2_("descriptor " << descriptor << " is not correctly formatted!");
+	if(!pch)_error_("descriptor " << descriptor << " is not correctly formatted!");
 
 	if (strncmp(pch,"scaled",6)==0){
 		/*we have a scaled variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("scaled descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("scaled descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 
@@ -44,9 +44,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return IndexedEnum;
@@ -55,9 +55,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return NodalEnum;
Index: issm/trunk/src/c/modules/Dakotax/SpawnCore.cpp
===================================================================
--- issm/trunk/src/c/modules/Dakotax/SpawnCore.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Dakotax/SpawnCore.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../io/io.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
Index: issm/trunk/src/c/modules/Dakotax/SpawnCoreParallel.cpp
===================================================================
--- issm/trunk/src/c/modules/Dakotax/SpawnCoreParallel.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Dakotax/SpawnCoreParallel.cpp	(revision 13395)
@@ -26,5 +26,5 @@
 
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../io/io.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
@@ -72,5 +72,5 @@
 	if(control_analysis)solutioncore=&control_core;
 	#else
-	_error2_("ISSM was not compiled with control capabilities, exiting!");
+	_error_("ISSM was not compiled with control capabilities, exiting!");
 	#endif
 
Index: issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp
===================================================================
--- issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp	(revision 13395)
+++ issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp	(revision 13395)
@@ -0,0 +1,23 @@
+/*!\file Delta18oParameterizationx
+ * \brief: Create past temperature field from present day fields
+ */
+
+#include "./Delta18oParameterizationx.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../io/io.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+void Delta18oParameterizationx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters){
+
+  /*Intermediary*/
+  int    i;
+  Element* element = NULL;
+ 
+  /*Compute temperature and precipitation fields: */
+  for(i=0;i<elements->Size();i++){
+    element=(Element*)elements->GetObjectByOffset(i);
+    element->Delta18oParameterization();
+  }  
+}
